Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/FragmentGraphView.Designer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/FragmentGraphView.Designer.cs	(revision 11890)
+++ 	(revision )
@@ -1,56 +1,0 @@
-﻿namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  partial class FragmentGraphView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.symbolicExpressionChartControl = new HeuristicLab.Problems.DataAnalysis.Symbolic.Views.SymbolicExpressionChartControl();
-      this.SuspendLayout();
-      // 
-      // symbolicExpressionChartControl
-      // 
-      this.symbolicExpressionChartControl.BackColor = System.Drawing.SystemColors.Control;
-      this.symbolicExpressionChartControl.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.symbolicExpressionChartControl.Location = new System.Drawing.Point(0, 0);
-      this.symbolicExpressionChartControl.Name = "symbolicExpressionChartControl";
-      this.symbolicExpressionChartControl.ScaleOnResize = true;
-      this.symbolicExpressionChartControl.Size = new System.Drawing.Size(1144, 682);
-      this.symbolicExpressionChartControl.TabIndex = 0;
-      this.symbolicExpressionChartControl.UpdateEnabled = true;
-      // 
-      // FragmentGraphView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.symbolicExpressionChartControl);
-      this.Name = "FragmentGraphView";
-      this.Size = new System.Drawing.Size(1144, 682);
-      this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.FragmentGraphView_KeyPress);
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private SymbolicExpressionChartControl symbolicExpressionChartControl;
-  }
-}
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/FragmentGraphView.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/FragmentGraphView.cs	(revision 11890)
+++ 	(revision )
@@ -1,232 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Drawing;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views;
-using HeuristicLab.MainForm;
-using HeuristicLab.Visualization;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  [View("FragmentGraphView")]
-  [Content(typeof(FragmentGraph), IsDefaultView = true)]
-  public sealed partial class FragmentGraphView : ItemView {
-    private const int PreferredHorizontalSpacing = 10;
-    private const int PreferredVerticalSpacing = 25;
-
-    private readonly ReingoldTilfordLayoutEngine<TileLayoutNode> layoutEngine;
-    private readonly ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode> symbolicExpressionEngine;
-
-    private readonly Dictionary<FragmentNode, TileLayoutNode> nodeToTileMap;
-
-    private SymbolicExpressionTreeTile Root { get; set; }
-
-    public new FragmentGraph Content {
-      get { return (FragmentGraph)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public FragmentGraphView() {
-      InitializeComponent();
-
-      layoutEngine = new ReingoldTilfordLayoutEngine<TileLayoutNode>(n => n.Children) {
-        HorizontalSpacing = PreferredHorizontalSpacing,
-        VerticalSpacing = PreferredVerticalSpacing,
-      };
-      symbolicExpressionEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees) {
-        HorizontalSpacing = PreferredHorizontalSpacing,
-        VerticalSpacing = PreferredVerticalSpacing,
-        NodeWidth = 80,
-        NodeHeight = 40
-      };
-      nodeToTileMap = new Dictionary<FragmentNode, TileLayoutNode>();
-    }
-
-    private void MakeTiles() {
-      var chart = symbolicExpressionChartControl.Chart;
-      nodeToTileMap.Clear();
-      foreach (var node in Content.Vertices) {
-        var tile = new SymbolicExpressionTreeTile(chart);
-        tile.LayoutEngine = symbolicExpressionEngine;
-        tile.Label = "Generation " + node.Rank + Environment.NewLine +
-                     "Quality " + String.Format("{0:0.000}", node.Quality);
-        tile.Root = node.Data.Root;
-        var tileNode = new TileLayoutNode { Tile = tile };
-        nodeToTileMap.Add(node, tileNode);
-      }
-      foreach (var node in Content.Vertices.Where(n => n.OutArcs.Any())) {
-        var layoutNode = nodeToTileMap[node];
-        layoutNode.Children = new List<TileLayoutNode>(node.OutArcs.Select(a => nodeToTileMap[(FragmentNode)a.Target]));
-      }
-    }
-
-    private void Draw() {
-      var chart = symbolicExpressionChartControl.Chart;
-      var nodes = Content.Vertices.ToList();
-      var root = nodes[0];
-      var fragmentRoot = nodeToTileMap[root];
-      int maxTileWidth = 0, maxTileHeight = 0;
-      var tiles = nodes.Select(x => nodeToTileMap[x].Tile).ToList();
-
-      foreach (var tile in tiles) {
-        var size = tile.Size;
-        if (maxTileWidth < size.Width) maxTileWidth = size.Width;
-        if (maxTileHeight < size.Height) maxTileHeight = size.Height;
-      }
-      layoutEngine.NodeWidth = maxTileWidth;
-      layoutEngine.NodeHeight = maxTileHeight;
-      layoutEngine.HorizontalSpacing = PreferredHorizontalSpacing;
-      layoutEngine.VerticalSpacing = PreferredVerticalSpacing;
-
-      var visualNodes = layoutEngine.CalculateLayout(fragmentRoot);
-
-      symbolicExpressionChartControl.UpdateEnabled = false;
-      foreach (var visualNode in visualNodes) {
-        var tile = visualNode.Content.Tile;
-        tile.Position = new Point(visualNode.X, visualNode.Y);
-        symbolicExpressionChartControl.Add(tile);
-      }
-
-      // add connections between the tiles
-      foreach (var node in nodes) {
-        var aTile = nodeToTileMap[node].Tile;
-        var aSize = aTile.Size;
-        var aPos = aTile.Position;
-        var tree = node.Data;
-
-        if (node.SubtreeIndex > 0) {
-          var subtree = tree.Root.NodeAt(node.SubtreeIndex);
-          foreach (var s in subtree.IterateNodesPrefix()) {
-            var primitive = aTile.GetPrimitive(s);
-            if (primitive != null) {
-              var rpb = primitive as RectangularPrimitiveBase;
-              if (rpb != null) {
-                rpb.Pen = new Pen(Color.Black);
-              }
-            }
-          }
-        }
-        if (node.FragmentIndex > 0) {
-          var subtree = tree.Root.NodeAt(node.FragmentIndex);
-          foreach (var s in subtree.IterateNodesPrefix()) {
-            var primitive = aTile.GetPrimitive(s);
-            if (primitive != null) {
-              var rpb = primitive as RectangularPrimitiveBase;
-              if (rpb != null) {
-                rpb.Brush = new SolidBrush(Color.LightGray);
-              }
-            }
-          }
-        }
-
-        if (node.InArcs.Any()) {
-          var parent = (FragmentNode)node.InArcs.First().Source;
-          if (parent.OutArcs.First().Target == node) {
-            var index = node.SubtreeIndex + (parent.FragmentIndex - parent.SubtreeIndex);
-            // some mutations create discontinuities which invalidate the index
-            if (index >= 0 && index < tree.Length) {
-              var subtree = tree.NodeAt(index);
-              var primitive = aTile.GetPrimitive(subtree);
-              primitive.Brush = new SolidBrush(Color.LightCoral);
-            }
-          }
-        }
-
-        foreach (var child in node.OutArcs.Select(x => (FragmentNode)x.Target)) {
-          var bTile = nodeToTileMap[child].Tile;
-          var bSize = bTile.Size;
-          var bPos = bTile.Position;
-
-          var line = new Line(chart, new PointD(aPos.X + aSize.Width / 2.0, aPos.Y + aSize.Height), new PointD(bPos.X + bSize.Width / 2.0, bPos.Y)) {
-            Pen = Pens.DimGray
-          };
-          symbolicExpressionChartControl.Add(line);
-        }
-      }
-      // center display on the root of the fragment graph
-      symbolicExpressionChartControl.Chart.Move(nodeToTileMap[root].Tile.Position.X, nodeToTileMap[root].Tile.Position.Y);
-      symbolicExpressionChartControl.UpdateEnabled = true;
-      symbolicExpressionChartControl.EnforceUpdate();
-    }
-
-    protected override void DeregisterContentEvents() {
-      // TODO: Deregister your event handlers here
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      // TODO: Register your event handlers here
-    }
-
-    #region Event Handlers (Content)
-    // TODO: Put event handlers of the content here
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content != null) {
-        MakeTiles();
-        Draw();
-      }
-    }
-    #endregion
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      // TODO: Enable or disable controls based on whether the content is null or the view is set readonly
-    }
-
-    private void FragmentGraphView_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e) {
-      if (e.KeyChar == 'i') {
-        // highlight node impacts
-      }
-    }
-
-    #region Event Handlers (child controls)
-
-    // TODO: Put event handlers of child controls here.
-
-    #endregion
-  }
-
-  internal static class Util {
-    internal static ISymbolicExpressionTreeNode NodeAt(this ISymbolicExpressionTree tree, int position) {
-      return NodeAt(tree.Root, position);
-    }
-    internal static ISymbolicExpressionTreeNode NodeAt(this ISymbolicExpressionTreeNode root, int position) {
-      return root.IterateNodesPrefix().ElementAt(position);
-    }
-  }
-
-  internal class TileLayoutNode {
-    public SymbolicExpressionTreeTile Tile { get; set; }
-
-    private List<TileLayoutNode> children;
-    public IEnumerable<TileLayoutNode> Children {
-      get { return children ?? Enumerable.Empty<TileLayoutNode>(); }
-      set { children = value.ToList(); }
-    }
-  }
-}
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/SymbolicDataAnalysisExpressionLineageExplorerView.Designer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/SymbolicDataAnalysisExpressionLineageExplorerView.Designer.cs	(revision 11890)
+++ 	(revision )
@@ -1,74 +1,0 @@
-﻿namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  partial class SymbolicDataAnalysisExpressionLineageExplorerView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.treeView = new System.Windows.Forms.TreeView();
-      this.symbolicExpressionChartControl = new HeuristicLab.Problems.DataAnalysis.Symbolic.Views.SymbolicExpressionChartControl();
-      this.SuspendLayout();
-      // 
-      // treeView
-      // 
-      this.treeView.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)));
-      this.treeView.Location = new System.Drawing.Point(3, 3);
-      this.treeView.Name = "treeView";
-      this.treeView.Size = new System.Drawing.Size(167, 590);
-      this.treeView.TabIndex = 0;
-      this.treeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView_AfterSelect);
-      // 
-      // symbolicExpressionChartControl
-      // 
-      this.symbolicExpressionChartControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.symbolicExpressionChartControl.AutoSize = true;
-      this.symbolicExpressionChartControl.BackColor = System.Drawing.SystemColors.Control;
-      this.symbolicExpressionChartControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
-      this.symbolicExpressionChartControl.Chart = null;
-      this.symbolicExpressionChartControl.Location = new System.Drawing.Point(176, 3);
-      this.symbolicExpressionChartControl.Name = "symbolicExpressionChartControl";
-      this.symbolicExpressionChartControl.ScaleOnResize = true;
-      this.symbolicExpressionChartControl.Size = new System.Drawing.Size(657, 593);
-      this.symbolicExpressionChartControl.TabIndex = 1;
-      // 
-      // SymbolicDataAnalysisExpressionLineageExplorerView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.symbolicExpressionChartControl);
-      this.Controls.Add(this.treeView);
-      this.DoubleBuffered = true;
-      this.Name = "SymbolicDataAnalysisExpressionLineageExplorerView";
-      this.Size = new System.Drawing.Size(836, 596);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.TreeView treeView;
-    private SymbolicExpressionChartControl symbolicExpressionChartControl;
-  }
-}
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/SymbolicDataAnalysisExpressionLineageExplorerView.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/SymbolicDataAnalysisExpressionLineageExplorerView.cs	(revision 11890)
+++ 	(revision )
@@ -1,88 +1,0 @@
-﻿using System.Collections.Generic;
-using System.Globalization;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views;
-using HeuristicLab.EvolutionTracking;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.Visualization;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  [View("LineageExplorerView")]
-  [Content(typeof(IGenealogyGraph), false)]
-  public partial class SymbolicDataAnalysisExpressionLineageExplorerView : AsynchronousContentView {
-    private readonly ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode> symbolicExpressionTreeNodeLayoutEngine;
-
-    private readonly Dictionary<TreeNode, ISymbolicExpressionTree> treeMap;
-
-    private const int MinHorizontalSpacing = 50;
-    private const int MinVerticalSpacing = 50;
-    private const int PreferredNodeWidth = 80;
-    private const int PreferredNodeHeight = 40;
-
-    public new IGenealogyGraph Content {
-      get { return (IGenealogyGraph)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public SymbolicDataAnalysisExpressionLineageExplorerView() {
-      InitializeComponent();
-      symbolicExpressionTreeNodeLayoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode>(node => node.Subtrees) {
-        HorizontalSpacing = MinHorizontalSpacing,
-        VerticalSpacing = MinVerticalSpacing,
-        NodeWidth = PreferredNodeWidth,
-        NodeHeight = PreferredNodeHeight
-      };
-
-      treeMap = new Dictionary<TreeNode, ISymbolicExpressionTree>();
-      double width = symbolicExpressionChartControl.PreferredSize.Width;
-      double height = symbolicExpressionChartControl.PreferredSize.Height;
-      if (symbolicExpressionChartControl.Chart == null) {
-        symbolicExpressionChartControl.Chart = new Chart(0, 0, width, height);
-      }
-    }
-
-    #region events
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content != null) { updateTreeView(); }
-    }
-    #endregion
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      treeView.Enabled = Content != null;
-    }
-
-    private void updateTreeView() {
-      var lastGen = Content.Ranks.OrderBy(x => x.Key).Last().Value.ToList();
-      treeMap.Clear();
-      symbolicExpressionChartControl.Clear();
-      foreach (var g in lastGen) {
-        var treeNode = new TreeNode(g.Quality.ToString(CultureInfo.InvariantCulture));
-        treeView.Nodes.Add(treeNode);
-        treeMap.Add(treeNode, (ISymbolicExpressionTree)g.Data);
-      }
-    }
-
-    private void treeView_AfterSelect(object sender, TreeViewEventArgs e) {
-      symbolicExpressionChartControl.Clear();
-      var selectedNode = treeView.SelectedNode;
-      var symbolicExpressionTree = treeMap[selectedNode];
-      var chart = symbolicExpressionChartControl.Chart;
-      var tile = new SymbolicExpressionTreeTile(chart) {
-        LayoutEngine = symbolicExpressionTreeNodeLayoutEngine,
-        PreferredNodeWidth = PreferredNodeWidth,
-        PreferredNodeHeight = PreferredNodeHeight,
-        SymbolicExpressionTree = symbolicExpressionTree
-      };
-      symbolicExpressionChartControl.UpdateEnabled = false;
-      symbolicExpressionChartControl.Add(tile);
-      //      symbolicExpressionChartControl.FlipVertical();
-      symbolicExpressionChartControl.UpdateEnabled = true;
-      symbolicExpressionChartControl.EnforceUpdate();
-    }
-  }
-}
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/SymbolicDataAnalysisGenealogyGraphView.resx
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Tracking/SymbolicDataAnalysisGenealogyGraphView.resx	(revision 11890)
+++ 	(revision )
@@ -1,120 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>